zoukankan      html  css  js  c++  java
  • Codeforces 672D Robin Hood(二分好题)

    D. Robin Hood
    time limit per test
    1 second
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    We all know the impressive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

    There are n citizens in Kekoland, each person has ci coins. Each day, Robin Hood will take exactly 1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest's 1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire in k days. He decided to spend these last days with helping poor people.

    After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too.

    Your task is to find the difference between richest and poorest persons wealth after k days. Note that the choosing at random among richest and poorest doesn't affect the answer.

    Input

    The first line of the input contains two integers n and k (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood's retirement.

    The second line contains n integers, the i-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

    Output

    Print a single line containing the difference between richest and poorest peoples wealth.

    Examples
    input
    4 1
    1 1 4 2
    
    output
    2
    
    input
    3 1
    2 2 2
    
    output
    0
    
    Note

    Lets look at how wealth changes through day in the first sample.

    1. [1, 1, 4, 2]
    2. [2, 1, 3, 2] or [1, 2, 3, 2]

    So the answer is 3 - 1 = 2

    In second sample wealth will remain the same for each person

    题目链接:Codeforces 672D

    题意就是求k天之后这个数列中最大和最小值之差应为多少,可以用二分去求出k天之后的最大值和最小值,显然对于最小值,它的下界为初始序列的最小值,随着k天过去,必定不会下降,又因为题意是从最大值偷取1单位到最小值,因此最小值过多少天必定不会超过整个数列的平均值,因此它的上界是$lfloor {{Sigma c_i} / n} floor$;对于最大值来说,它的上界显然是最好情况——数列初始的最大值,随着时间过去最大值必定减小,但与最小值类似也不会小于平均值,当${Sigma c_i} \%n!=0$时说明最终最大值必定会比平均值多1,因此它此时的下界为$lfloor {Sigma c_i} /n floor+1$,否则下界为$lfloor{Sigma c_i} /n floor$,对于当前二分的最值,如果可行,那么说明最终的结果肯定优于或等于当前结果,继续二分下去,就能得到最后的结果

    代码:

    #include <stdio.h>
    #include <algorithm>
    #include <cstdlib>
    #include <cstring>
    #include <bitset>
    #include <string>
    #include <stack>
    #include <cmath>
    #include <queue>
    #include <set>
    #include <map>
    using namespace std;
    #define INF 0x3f3f3f3f
    #define LC(x) (x<<1)
    #define RC(x) ((x<<1)+1)
    #define MID(x,y) ((x+y)>>1)
    #define fin(name) freopen(name,"r",stdin)
    #define fout(name) freopen(name,"w",stdout)
    #define CLR(arr,val) memset(arr,val,sizeof(arr))
    #define FAST_IO ios::sync_with_stdio(false);cin.tie(0);
    typedef pair<int, int> pii;
    typedef long long LL;
    const double PI = acos(-1.0);
    const int N = 500010;
    LL arr[N];
    int n;
    LL k;
    
    LL checkpoor(LL mid, LL res)
    {
        for (int i = 0; i < n; ++i)
        {
            if (arr[i] < mid)
            {
                res -= (mid - arr[i]);
            }
        }
        return res >= 0;
    }
    LL checkrich(LL mid, LL res)
    {
        for (int i = 0; i < n; ++i)
        {
            if (arr[i] > mid)
                res -= (arr[i] - mid);
        }
        return res >= 0;
    }
    int main(void)
    {
        int i;
        while (~scanf("%d%I64d", &n, &k))
        {
            LL sum = 0;
            for (i = 0; i < n; ++i)
            {
                scanf("%I64d", arr + i);
                sum += arr[i];
            }
            LL Max = 0, Min = 0;
            //poorest
            LL L = *min_element(arr, arr + n), R = sum / n;
            while (L <= R)
            {
                LL mid = MID(L, R);
                if (checkpoor(mid, k))
                {
                    L = mid + 1;
                    Min = mid;
                }
                else
                    R = mid - 1;
            }
            //richest
            L = sum / n + (sum % n != 0), R = *max_element(arr, arr + n);
            while (L <= R)
            {
                LL mid = MID(L, R);
                if (checkrich(mid, k))
                {
                    R = mid - 1;
                    Max = mid;
                }
                else
                    L = mid + 1;
            }
            printf("%I64d
    ", Max - Min);
        }
        return 0;
    }
  • 相关阅读:
    电源锁
    Android的三种网络联接方式
    用tcpdump在手机上抓包
    图片出现波纹的问题
    Android 3.1以后 广播接收器的新机制
    OpenGL坐标
    用Messager进行IPC
    PHP 介绍
    View坐标,MotionEvent坐标, 二者的转换,可视区域
    OpenGL ES
  • 原文地址:https://www.cnblogs.com/Blackops/p/7372567.html
Copyright © 2011-2022 走看看